package com.pj.project.tb_gate_terminal.task;

import com.pj.current.config.MyConfig;
import com.pj.project.tb_gate_terminal.TbGateTerminal;
import com.pj.project.tb_gate_terminal.TbGateTerminalService;
import com.pj.utils.zkt.GateCommandUtils;
import com.pj.utils.zkt.ZKTecoUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.util.Date;
import java.util.List;

@Component
@Slf4j
public class TestStateTask {
    @Resource
    private TbGateTerminalService tbGateTerminalService;

    @Resource
    private MyConfig myConfig;

    @Scheduled(fixedRate = 45000)
    @Async
    public void testState() {
        List<TbGateTerminal> list = tbGateTerminalService.list();
        list.parallelStream().forEach(tbGateTerminal -> {
            Socket socket = new Socket();
            try {
                socket.connect(new InetSocketAddress(tbGateTerminal.getIp(), myConfig.getGatePort()), 4000);
                tbGateTerminal.setState("在线").setLastOnlineTime(new Date());
            } catch (IOException e) {
                log.error("检测在线异常:{}", e.getMessage());
                tbGateTerminal.setState("离线");
            }
        });
        if (!list.isEmpty()) {
            tbGateTerminalService.updateBatchById(list);
        }
    }
}
